! WHIZARD <<Version>> <<Date>>
! 
! Copyright (C) 1999-2019 by 
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!     with contributions from
!     cf. main AUTHORS file
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module system_dependencies

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! All character strings indented by 7 blanks will be automatically
  ! split into chunks respecting the FORTRAN line length constraint by
  ! configure.
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use, intrinsic :: omp_lib

  implicit none
  public
 
  ! Program version
  character(*), parameter :: WHIZARD_VERSION = "2.8.2"
  character(*), parameter :: WHIZARD_DATE = "Oct 24 2019"

  ! System paths
  ! These are used for testing without existing installation
  character(*), parameter :: WHIZARD_TEST_BASICS_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/basics"
  character(*), parameter :: WHIZARD_TEST_UTILITIES_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/utilities"
  character(*), parameter :: WHIZARD_TEST_COMBINATORICS_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/combinatorics"
  character(*), parameter :: WHIZARD_TEST_SYSTEM_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/system"
  character(*), parameter :: WHIZARD_TEST_PHYSICS_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/physics"
  character(*), parameter :: WHIZARD_TEST_ME_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/matrix_elements"
  character(*), parameter :: WHIZARD_TEST_MODELS_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/models"
  character(*), parameter :: WHIZARD_TEST_THRESHOLD_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/threshold"
  character(*), parameter :: WHIZARD_TEST_OMEGA_MODPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/omega/src"
  character(*), parameter :: WHIZARD_TEST_CORE_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/whizard-core"
  character(*), parameter :: WHIZARD_TEST_OMEGA_BINPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/omega/bin"
  character(*), parameter :: WHIZARD_TEST_SRC_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src"
  character(*), parameter :: WHIZARD_TEST_HEPMC_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/hepmc"
  character(*), parameter :: WHIZARD_TEST_LCIO_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/lcio"
  character(*), parameter :: WHIZARD_TEST_HOPPET_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/hoppet"
  character(*), parameter :: WHIZARD_TEST_LOOPTOOLS_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/looptools"
  character(*), parameter :: WHIZARD_TEST_MODELPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/models"
  character(*), parameter :: WHIZARD_TEST_MODELPATH_UFO = &
       "/builddir/build/BUILD/whizard-2.8.2/share/models/UFO"
  character(*), parameter :: WHIZARD_TEST_MODELS_LIBPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/models"
  character(*), parameter :: WHIZARD_TEST_SUSYPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/susy"
  character(*), parameter :: WHIZARD_TEST_GMLPATH= &
       "/builddir/build/BUILD/whizard-2.8.2/src/gamelan"
  character(*), parameter :: WHIZARD_TEST_CUTSPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/cuts"
  character(*), parameter :: WHIZARD_TEST_SHAREPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share"
  character(*), parameter :: WHIZARD_TEST_TESTDATAPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/test"
  character(*), parameter :: WHIZARD_TEST_TEXPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/src/feynmf"
  character(*), parameter :: WHIZARD_TEST_CIRCE2PATH = &
       "/builddir/build/BUILD/whizard-2.8.2/circe2/share/data"
  character(*), parameter :: WHIZARD_TEST_BEAMSIMPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/beam-sim"
  character(*), parameter :: WHIZARD_TEST_MULIPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/muli"
  character(*), parameter :: PDF_BUILTIN_TEST_DATAPATH = &
       "/builddir/build/BUILD/whizard-2.8.2/share/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_TEST_INCLUDES = &
       "-I" // WHIZARD_TEST_MODELS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_THRESHOLD_MODPATH // " " // &
       "-I" // WHIZARD_TEST_OMEGA_MODPATH // " " // &
       "-I" // WHIZARD_TEST_ME_MODPATH // " " // &
       "-I" // WHIZARD_TEST_PHYSICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_SYSTEM_MODPATH // " " // &
       "-I" // WHIZARD_TEST_COMBINATORICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_UTILITIES_MODPATH // " " // &
       "-I" // WHIZARD_TEST_BASICS_MODPATH // " " // &
       "-I/usr/lib64/openloops/lib_src/openloops/mod " 

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_TEST_LDFLAGS = &
       "-L" // WHIZARD_TEST_CORE_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_SRC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HEPMC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LCIO_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HOPPET_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LOOPTOOLS_LIBPATH // " " // &
       "-lwhizard_main -lwhizard -lomega " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3   " // &
       "-L/usr/lib64 -looptools -Wl,-rpath,/usr/lib64/openloops/lib -L&
       &/usr/lib64/openloops/lib  -Wl,-rpath,/usr/lib64/openloops/lib64 -L/usr&
       &/lib64/openloops/lib64 -lopenloops " // &
       ""

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL_TEST = &
       "/builddir/build/BUILD/whizard-2.8.2/libtool"


  ! System paths
  ! These are used for the installed version
  character(*), parameter :: PREFIX = &
       "/usr"
  character(*), parameter :: EXEC_PREFIX = &
       "${prefix}"
  character(*), parameter :: BINDIR = &
       "${exec_prefix}/bin"
  character(*), parameter :: LIBDIR = &
       "/usr/lib64"
  character(*), parameter :: INCLUDEDIR = &
       "${prefix}/include"
  character(*), parameter :: DATAROOTDIR = &
       "${prefix}/share"

  character(*), parameter :: PKGLIBDIR = LIBDIR  // "/whizard"
  character(*), parameter :: PKGDATADIR = DATAROOTDIR // "/whizard"
  character(*), parameter :: PKGTEXDIR = DATAROOTDIR // "/texmf/whizard"
  character(*), parameter :: PKGCIRCE2DIR = DATAROOTDIR // "/circe2"

  character(*), parameter :: WHIZARD_BASICS_MODPATH = &
       PKGLIBDIR // "/mod/basics"
  character(*), parameter :: WHIZARD_UTILITIES_MODPATH = &
       PKGLIBDIR // "/mod/utilities"
  character(*), parameter :: WHIZARD_COMBINATORICS_MODPATH = &
       PKGLIBDIR // "/mod/combinatorics"
  character(*), parameter :: WHIZARD_SYSTEM_MODPATH = &
       PKGLIBDIR // "/mod/system"
  character(*), parameter :: WHIZARD_PHYSICS_MODPATH = &
       PKGLIBDIR // "/mod/physics"
  character(*), parameter :: WHIZARD_ME_MODPATH = &
       PKGLIBDIR // "/mod/matrix_elements"
  character(*), parameter :: WHIZARD_MODELS_MODPATH = &
       PKGLIBDIR // "/mod/models"
  character(*), parameter :: WHIZARD_THRESHOLD_MODPATH = &
       PKGLIBDIR // "/mod/threshold"
  character(*), parameter :: WHIZARD_OMEGA_MODPATH = &
       INCLUDEDIR // "/omega"
  character(*), parameter :: WHIZARD_OMEGA_BINPATH = &
       BINDIR
  character(*), parameter :: WHIZARD_OMEGA_LIBPATH = &
       LIBDIR
  character(*), parameter :: WHIZARD_MODELPATH = &
       PKGDATADIR // "/models"
  character(*), parameter :: WHIZARD_MODELPATH_UFO = &
       PKGDATADIR // "/models/UFO"
  character(*), parameter :: WHIZARD_MODELS_LIBPATH = &
       PKGLIBDIR // "/models"
  character(*), parameter :: WHIZARD_SUSYPATH = &
       PKGDATADIR // "/susy"
  character(*), parameter :: WHIZARD_GMLPATH= &
       PKGLIBDIR // "/gamelan"
  character(*), parameter :: WHIZARD_SHAREPATH = &
       PKGDATADIR
  character(*), parameter :: WHIZARD_TESTDATAPATH = &
       PKGDATADIR // "/test"
  character(*), parameter :: WHIZARD_CUTSPATH = &
       PKGDATADIR // "/cuts"
  character(*), parameter :: WHIZARD_TEXPATH = &
       PKGTEXDIR
  character(*), parameter :: WHIZARD_CIRCE2PATH = &
       PKGCIRCE2DIR // "/data"
  character(*), parameter :: WHIZARD_BEAMSIMPATH = &
       PKGDATADIR // "/beam-sim"
  character(*), parameter :: WHIZARD_MULIPATH = &
       PKGDATADIR // "/muli"
  character(*), parameter :: PDF_BUILTIN_DATAPATH = &
       PKGDATADIR // "/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_INCLUDES = &
      "-I" // WHIZARD_MODELS_MODPATH // " " // &
      "-I" // WHIZARD_THRESHOLD_MODPATH // " " // &
      "-I" // WHIZARD_OMEGA_MODPATH // " " // &
      "-I" // WHIZARD_ME_MODPATH // " " // &
      "-I" // WHIZARD_PHYSICS_MODPATH // " " // &
      "-I" // WHIZARD_SYSTEM_MODPATH // " " // &
      "-I" // WHIZARD_COMBINATORICS_MODPATH // " " // &
      "-I" // WHIZARD_UTILITIES_MODPATH // " " // &
      "-I" // WHIZARD_BASICS_MODPATH // " " // &
       "-I/usr/lib64/openloops/lib_src/openloops/mod "

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_LDFLAGS = &
      "-L" // WHIZARD_OMEGA_LIBPATH // " " // &
      "-lwhizard_main -lwhizard -lomega " // &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3   " // &
       "-L/usr/lib64 -looptools -Wl,-rpath,/usr/lib64/openloops/lib -L&
       &/usr/lib64/openloops/lib  -Wl,-rpath,/usr/lib64/openloops/lib64 -L/usr&
       &/lib64/openloops/lib64 -lopenloops " // &
       ""

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL = &
      PKGLIBDIR // "/libtool"


  ! Fortran compiler
  character(*), parameter :: DEFAULT_FC = &
       "gfortran"
  character(*), parameter :: DEFAULT_FCFLAGS = &
       " -fopenmp  -g -O2"
  character(*), parameter :: DEFAULT_FCFLAGS_PIC = &
       " -fPIC"
  character(*), parameter :: DEFAULT_FC_SRC_EXT = &
       ".f90"
  character(*), parameter :: DEFAULT_FC_PRECISION = &
       "double"
  
  ! Fortran compiler
  character(*), parameter :: DEFAULT_CC = &
       "gcc"
  character(*), parameter :: DEFAULT_CFLAGS = &
       "-g -O2"
  character(*), parameter :: DEFAULT_CFLAGS_PIC = &
       ""
  logical, parameter :: CC_IS_GNU = .true.
  logical, parameter :: CC_HAS_QUADMATH = .true.
  
  ! Object files
  character(*), parameter :: DEFAULT_OBJ_EXT = &
       ".o"

  ! Linker
  character(*), parameter :: DEFAULT_LD = &
       "/opt/rh/devtoolset-8/root/usr/libexec/gcc/x86_64-redhat-linux/&
       &8/ld -m elf_x86_64"
  character(*), parameter :: DEFAULT_LDFLAGS = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_SO = "-shared"
  character(*), parameter :: DEFAULT_LDFLAGS_STATIC = &
       "-lstdc++"
  character(*), parameter :: DEFAULT_LDFLAGS_HEPMC = &
       "-Wl,-rpath,/usr/lib64 -L/usr/lib64 -lHepMC3"
  character(*), parameter :: DEFAULT_LDFLAGS_LCIO = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_HOPPET = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_LOOPTOOLS = &
       "-L/usr/lib64 -looptools"
  character(*), parameter :: DEFAULT_SHRLIB_EXT = "so"
  character(*), parameter :: DEFAULT_FC_SHRLIB_EXT = "so"

  ! Pack/unpack
  character(*), parameter :: DEFAULT_PACK_CMD = "tar -czf"
  character(*), parameter :: DEFAULT_UNPACK_CMD = "tar -xzf"
  character(*), parameter :: DEFAULT_PACK_EXT = ".tgz"

  ! Make
  character(*), parameter :: DEFAULT_MAKEFLAGS = &
       "-j1"

  ! LHAPDF library
  character(*), parameter :: LHAPDF_PDFSETS_PATH = &
       "/usr/share/LHAPDF"

  ! Available methods for event analysis display
  character(*), parameter :: EVENT_ANALYSIS = &
       "no"
  character(*), parameter :: EVENT_ANALYSIS_PS = &
       "no"
  character(*), parameter :: EVENT_ANALYSIS_PDF = &
       "no"

  ! Programs used for event analysis display
  character(*), parameter :: PRG_LATEX  = &
       "no"
  character(*), parameter :: PRG_MPOST  = &
       "no"
  character(*), parameter :: PRG_DVIPS  = &
       "no"
  character(*), parameter :: PRG_PS2PDF = &
       "no"

  ! Programs and libraries used for NLO calculations
  ! GoSam
  character(*), parameter :: GOSAM_DIR = &
       "/usr"
  character(*), parameter :: GOLEM_DIR = &
       "/usr"
  character(*), parameter :: FORM_DIR = &
       "/usr"
  character(*), parameter :: QGRAF_DIR = &
       "/usr"
  character(*), parameter :: NINJA_DIR = &
       "/usr"
  character(*), parameter :: SAMURAI_DIR = &
       "/usr"

  ! OpenLoops
  character(*), parameter :: OPENLOOPS_DIR = &
       "/usr/lib64/openloops"
  character(*), parameter :: RECOLA_DIR = &
       ""  

  ! Hardwired options for batch-mode processing
  character(*), parameter :: OPT_LATEX  = &
       "-halt-on-error"
  character(*), parameter :: OPT_MPOST  = &
       " -halt-on-error"

  ! dlopen parameters
  integer, parameter :: &
     RTLD_LAZY   = 1 , &
     RTLD_NOW    = 2 , &
     RTLD_GLOBAL = 256 , &
     RTLD_LOCAL  = 0

  ! Misc
  logical, parameter :: LHAPDF5_AVAILABLE = .false.
  logical, parameter :: LHAPDF6_AVAILABLE = .true.
  logical, parameter :: HEPMC2_AVAILABLE = .false.
  logical, parameter :: HEPMC3_AVAILABLE = .true.
  logical, parameter :: HOPPET_AVAILABLE = .false.

  logical, parameter :: PYTHIA6_AVAILABLE = .true.
  logical, parameter :: PYTHIA8_AVAILABLE = .true.

  logical, parameter :: GOSAM_AVAILABLE = .true.
  logical, parameter :: OPENLOOPS_AVAILABLE = .true.
  logical, parameter :: RECOLA_AVAILABLE = .false.  

contains

  ! Subroutines that depend on configure settings

  ! OpenMP wrapper routines, work independent of OpenMP status
  function openmp_is_active () result (flag)
    logical :: flag
    flag = .true.
!    flag = .false.
  end function openmp_is_active

  subroutine openmp_set_num_threads (num)
    integer, intent(in) :: num
    call omp_set_num_threads (num)
  end subroutine openmp_set_num_threads
  
  function openmp_get_num_threads () result (num)
    integer :: num
    num = omp_get_num_threads ()
!    num = 1
  end function openmp_get_num_threads
  
  function openmp_get_max_threads () result (num)
    integer :: num
    num = omp_get_max_threads ()
!    num = 1
  end function openmp_get_max_threads
  
  function openmp_get_default_max_threads () result (num)
    integer :: num
    num = 2
  end function openmp_get_default_max_threads

end module system_dependencies
